part of 'app_test.dart';

class VehicleTest {
  static Future<void> vehiclePage() async {
    patrol(
      'Vehicle Page',
      (PatrolIntegrationTester tester) async {
        $ = tester;
        $.tester.printToConsole('Vehicle Page');
        final PatrolFinder throwsException = $(Dialog).$(ThrowExceptionWidget);

        await _loggedWithMultiLocalsAccount($);
        await $.pumpWidgetAndSettle(const App());

        ff.navigatorKey.currentContext!.go('/vehiclesOnThePropertyPage');

        final String title = MenuEntry.entries //
            .where((entry) => entry.key == 'FRE-HUB-VEHICLES') //
            .map((entry) => entry.name)
            .first;

        final PatrolFinder appBar = await $(AppBar) //
            .waitUntilExists();
        final PatrolFinder titleAppBar = await appBar //
            .$(title)
            .waitUntilVisible();
        expect(titleAppBar, findsOneWidget);

        final PatrolFinder tab1 = await $(#TabView_Tab1) //
            .waitUntilExists();
        final PatrolFinder tab2 = await $(#TabView_Tab2) //
            .waitUntilExists();

        await tab2.tap();
        await Future.delayed(const Duration(milliseconds: 500));
        await tab1.tap();

        final PatrolFinder listViewFinder = await $(VehicleHistoryScreen) //
            .$(ListView)
            .waitUntilVisible();

        expect(listViewFinder, findsOneWidget);

        final PatrolFinder entriesFinder =
            await $(listViewFinder).$(CardItemTemplateComponentWidget).waitUntilVisible();

        expect(entriesFinder, findsWidgets);
        final int entriesCount = entriesFinder.evaluate().length;
        await $.pumpAndSettle();

        for (int i = 0; i < entriesCount; i++) {
          await $(entriesFinder.at(i)).scrollTo();

          await $(entriesFinder.at(i)).waitUntilVisible(timeout: const Duration(seconds: 1)).tap(
                settleTimeout: const Duration(seconds: 1),
                settlePolicy: SettlePolicy.noSettle,
              );

          await $.pumpAndSettle(duration: Duration(milliseconds: 500));
          final PatrolFinder detailsFinder = await $(DetailsComponentWidget).waitUntilVisible();
          expect(detailsFinder, findsOneWidget);

          await $.native.pressBack().then((_) => $.pumpAndSettle());
        }
      },
    );
    patrol(
      'License',
      (PatrolIntegrationTester tester) async {
        $ = tester;
        $.tester.printToConsole('Vehicle Page');

        await _loggedWithMultiLocalsAccount($);

        // await StorageHelper().set(
        //   LicenseKeys.vehiclesManager.value,
        //   <String, dynamic>{
        //     'display': 'VISIVEL',
        //     'expirationDate': '',
        //     'startDate': '',
        //     'quantity': 0,
        //   },
        // );
        // // await $.pumpAndSettle();
        // ff.navigatorKey.currentContext!.go('/vehiclesOnThePropertyPage');
        // await Future.delayed(const Duration(milliseconds: 1000));

        await StorageHelper().set(
          LicenseKeys.vehiclesManager.value,
          <String, dynamic>{
            'display': 'VISIVEL',
            'expirationDate': '',
            'startDate': '',
            'quantity': 0,
          },
        );
        await $.pumpWidgetAndSettle(const App());

        ff.navigatorKey.currentContext!.go('/vehiclesOnThePropertyPage');
        final String title = MenuEntry.entries //
            .where((entry) => entry.key == 'FRE-HUB-VEHICLES') //
            .map((entry) => entry.name)
            .first;

        final PatrolFinder appBar = await $(AppBar) //
            .waitUntilExists();
        final PatrolFinder titleAppBar = await appBar //
            .$(title)
            .waitUntilVisible();
        expect(titleAppBar, findsOneWidget);

        final PatrolFinder tab1 = await $(#TabView_Tab1) //
            .waitUntilExists();
        final PatrolFinder tab2 = await $(#TabView_Tab2) //
            .waitUntilExists();

        await tab2.tap();
        await Future.delayed(const Duration(milliseconds: 500));
        await tab1.tap();

        final PatrolFinder listViewFinder = await $(VehicleHistoryScreen) //
            .$(ListView)
            .waitUntilVisible();

        expect(listViewFinder, findsOneWidget);

        final PatrolFinder entriesFinder =
            await $(listViewFinder).$(CardItemTemplateComponentWidget).waitUntilVisible();

        expect(entriesFinder, findsWidgets);
        await $.pumpAndSettle();
        await Future.delayed(const Duration(milliseconds: 1000));
      },
    );
  }

  static Future<void> historyScreen() async {
    patrol(
      'historyScreen',
      (PatrolIntegrationTester tester) async {
        $ = tester;
        $.tester.printToConsole('Vehicle Page');
        final PatrolFinder throwsException = $(Dialog).$(ThrowExceptionWidget);

        await _loggedWithMultiLocalsAccount($);
        await $.pumpWidgetAndSettle(const App());

        ff.navigatorKey.currentContext!.go('/vehiclesOnThePropertyPage');

        final String title = MenuEntry.entries //
            .where((entry) => entry.key == 'FRE-HUB-VEHICLES') //
            .map((entry) => entry.name)
            .first;

        final PatrolFinder appBar = await $(AppBar) //
            .waitUntilExists();
        final PatrolFinder titleAppBar = await appBar //
            .$(title)
            .waitUntilVisible();
        expect(titleAppBar, findsOneWidget);

        final PatrolFinder tab2 = await $(#TabView_Tab2) //
            .waitUntilExists();

        await tab2.tap();

        final PatrolFinder listViewFinder = await $(VehicleHistoryScreen) //
            .$(ListView)
            .waitUntilVisible();

        expect(listViewFinder, findsOneWidget);

        final PatrolFinder entriesFinder =
            await $(listViewFinder).$(CardItemTemplateComponentWidget).waitUntilVisible();

        expect(entriesFinder, findsWidgets);
        final int entriesCount = entriesFinder.evaluate().length;
        await $.pumpAndSettle();

        for (int i = 0; i < entriesCount; i++) {
          await $(entriesFinder.at(i)).scrollTo();

          await $(entriesFinder.at(i)).waitUntilVisible(timeout: const Duration(seconds: 1)).tap(
                settleTimeout: const Duration(seconds: 1),
                settlePolicy: SettlePolicy.noSettle,
              );

          await $.pumpAndSettle(duration: Duration(milliseconds: 500));
          final PatrolFinder detailsFinder = await $(DetailsComponentWidget).waitUntilVisible();
          expect(detailsFinder, findsOneWidget);

          await $.native.pressBack().then((_) => $.pumpAndSettle());
        }
      },
    );
  }

  static Future<void> registerScreen() async {}
  static Future<void> updateScreen() async {}
}
