import 'package:flutter/material.dart';
import 'package:hub/components/organism_components/up_arrow_linked_locals_component/up_arrow_linked_locals_component_widget.dart';
import 'package:hub/features/storage/index.dart';
import 'package:hub/flutter_flow/flutter_flow_model.dart';

class UpArrowLinkedLocalsComponentModel
    extends FlutterFlowModel<UpArrowLinkedLocalsComponentWidget> {
  late final String devUUID;
  late final String userUUID;
  late final String cliUUID;
  late final String cliName;

  @override
  void initState(BuildContext context) {
    initDB();
  }

  Future<void> initDB() async {
    devUUID = (await StorageHelper().get(ProfileStorageKey.devUUID.key)) ?? '';
    userUUID =
        (await StorageHelper().get(ProfileStorageKey.userUUID.key)) ?? '';
    cliUUID =
        (await StorageHelper().get(ProfileStorageKey.clientUUID.key)) ?? '';
    cliName =
        (await StorageHelper().get(ProfileStorageKey.clientName.key)) ?? '';
  }

  @override
  void dispose() {}
}
