import 'dart:developer';

class DateTimeUtil {
  static Future<bool> processStartDate(String startDate) async {
    try {
      if (startDate.isEmpty) return true;
      final start = DateTime.tryParse(startDate);
      if (start == null) return false;
      return DateTime.now().isAfter(start);
    } catch (e) {
      log('Error processing start date for module: $e');
    }
    return false;
  }

  static Future<bool> processExpirationDate(String expirationDate) async {
    try {
      if (expirationDate.isEmpty) return false;
      final expiration = DateTime.tryParse(expirationDate);
      return expiration != null && DateTime.now().isAfter(expiration);
    } catch (e) {
      log('Error processing expiration date for module: $e');
    }
    return false;
  }
}
