import 'package:hub/features/module/index.dart';
import 'package:hub/flutter_flow/index.dart';
import 'package:hub/shared/utils/datetime_util.dart';

class LicenseUtil {
  static Future<bool> processModule(String? module) async {
    if (module == null) return false;
    final moduleMap = await stringToMap(module);
    final startDate = moduleMap['startDate'] ?? '';
    final expirationDate = moduleMap['expirationDate'] ?? '';
    final isStarted = await DateTimeUtil.processStartDate(startDate);
    final isExpired = await DateTimeUtil.processExpirationDate(expirationDate);
    if (isStarted && !isExpired) return EnumDisplay.fromString(moduleMap["display"]) == EnumDisplay.active;
    if (isExpired) return false;
    return false;
  }
}
